# Class AbstractRefactoringDescriptorResourceMapping

java.lang.Object
org.eclipse.core.runtime.PlatformObject
org.eclipse.core.resources.mapping.ResourceMapping
org.eclipse.ltk.core.refactoring.model.AbstractRefactoringDescriptorResourceMapping

All Implemented Interfaces:
  `IAdaptable`

public abstract class AbstractRefactoringDescriptorResourceMapping extends ResourceMapping
Partial implementation of a resource mapping for a refactoring descriptor object.

Note: this class is intended to be implemented by clients which need to enhance a model provider with a refactoring model.

Since:
  3.2
See Also:
  - `ResourceMapping`
  - `ModelProvider`

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`AbstractRefactoringDescriptorResourceMapping(RefactoringDescriptorProxy descriptor)`
Creates a new abstract refactoring descriptor resource mapping.

## Method Summary

Modifier and Type
Method
Description
`boolean`
`equals(Object object)`
Override equals to compare the model objects of the mapping in order to determine equality.
`final Object`
`getModelObject()`
Returns the application model element associated with this resource mapping.
`final IProject[]`
`getProjects()`
Returns the projects that contain the resources that constitute this application model.
`final IResource`
`getResource()`
Returns the associated resource.
`final ResourceTraversal[]`
`getTraversals(ResourceMappingContext context, IProgressMonitor monitor)`
Returns one or more traversals that can be used to access all the physical resources that constitute the logical resource.
`int`
`hashCode()`
Override hashCode to use the model object.

### Methods inherited from class ResourceMapping

`accept, contains, findMarkers, getModelProvider, getModelProviderId`

### Methods inherited from class PlatformObject

`getAdapter`

### Methods inherited from class Object

`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### AbstractRefactoringDescriptorResourceMapping

protected AbstractRefactoringDescriptorResourceMapping(RefactoringDescriptorProxy descriptor)
Creates a new abstract refactoring descriptor resource mapping.

Parameters:
  `descriptor` - the refactoring descriptor

## Method Details

### equals

public boolean equals(Object object)
Description copied from class: `ResourceMapping`
Override equals to compare the model objects of the mapping in order to determine equality.

Overrides:
  `equals` in class `ResourceMapping`
Parameters:
  `object` - the object to compare
Returns:
  `true` if the receiver is equal to the given object, and `false` otherwise.

### getModelObject

public final Object getModelObject()
Description copied from class: `ResourceMapping`
Returns the application model element associated with this resource mapping.

Specified by:
  `getModelObject` in class `ResourceMapping`
Returns:
  the application model element associated with this resource mapping.

### getProjects

public final IProject[] getProjects()
Description copied from class: `ResourceMapping`
Returns the projects that contain the resources that constitute this application model.

Specified by:
  `getProjects` in class `ResourceMapping`
Returns:
  the projects

### getResource

public final IResource getResource()
Returns the associated resource.

Returns:
  the associated resource, or `null` if the descriptor contains no timestamp or project information

### getTraversals

public final ResourceTraversal[] getTraversals(ResourceMappingContext context, IProgressMonitor monitor) throws CoreException
Description copied from class: `ResourceMapping`
Returns one or more traversals that can be used to access all the physical resources that constitute the logical resource. A traversal is simply a set of resources and the depth to which they are to be traversed. This method returns an array of traversals in order to provide flexibility in describing the traversals that constitute a model element.

Subclasses should, when possible, include all resources that are or may be members of the model element. For instance, a model element should return the same list of resources regardless of the existence of the files on the file system. For example, if a logical resource called "form" maps to "/p1/form.xml" and "/p1/form.java" then whether form.xml or form.java existed, they should be returned by this method.

In some cases, it may not be possible for a model element to know all the resources that may constitute the element without accessing the state of the model element in another location (e.g. a repository). This method is provided with a context which, when provided, gives access to the members of corresponding remote containers and the contents of corresponding remote files. This gives the model element the opportunity to deduce what additional resources should be included in the traversal.

Specified by:
  `getTraversals` in class `ResourceMapping`
Parameters:
  `context` - gives access to the state of remote resources that correspond to local resources for the purpose of determining traversals that adequately cover the model element resources given the state of the model element in another location. This parameter may be `null`, in which case the implementor can assume that only the local resources are of interest to the client.
  `monitor` - a progress monitor, or `null` if progress reporting is not desired
Returns:
  a set of traversals that cover the resources that constitute the model element
Throws:
  `CoreException` - if the traversals could not be obtained.

### hashCode

public int hashCode()
Description copied from class: `ResourceMapping`
Override hashCode to use the model object.

Overrides:
  `hashCode` in class `ResourceMapping`